function retrieve() {
	var titleList = [];
	var descList = [];

	titleList.push(document.title);

	var metaTags=document.getElementsByTagName("meta");
	for (var i = 0; i < metaTags.length; i++) {
		var property = metaTags[i].getAttribute("property");
		if (property == "og:title") {
			titleList.push(metaTags[i].getAttribute("content"));
		}
		else if (property == "og:description") {
			descList.push(metaTags[i].getAttribute("content"));
		}
		else if (property == "og:image") {
			onAddImage(metaTags[i].getAttribute("content"));
		}
		else if (metaTags[i].getAttribute("name") == "description") {
			descList.push(metaTags[i].getAttribute("content"));
		}
	}

	var images = document.getElementsByTagName("img");
	for(var i = 0; i < images.length; i++) {
		onAddImage(images[i].src);
	}

	var jsonTitle = JSON.stringify(titleList);
	var jsonDesc = JSON.stringify(descList);

	window.parseEventListener.onParseCompleted(jsonTitle, jsonDesc);
}

function onNodeInserted (event) {
	console.log("[onNodeInserted]");
	scanImages();
}

var bc_images = [];
function scanImages() {
	//console.log("[Mika] scanImages start");
	for (var i = 0; i < document.images.length; i++) {
		//console.log("[Mika] document.images[" + i + "].src = " + document.images[i].src);
		if (bc_images.indexOf(document.images[i].src) >= 0) {
			// This image has been called back.
			continue;
		}
		onAddImage(document.images[i].src);
		console.log("[New Image] " + document.images[i].width + "x" + document.images[i].height + "; " + document.images[i].src);
	}
	bc_images.sort();
	//console.log("[Mika] scanImages end");
}

function onAddImage(imgSrc) {
	if (bc_images.indexOf(imgSrc) < 0) {
		bc_images.push(imgSrc);
		window.parseEventListener.onAddImage(imgSrc);
	}
}

// Listen the DOMNodeInserted for detection of new added images.
console.log(document);
document.addEventListener('DOMNodeInserted', onNodeInserted, false);

// Scan once in case of the DOM tree won't be modified after onPageFinished.
retrieve();
